import { PropsWithRef, ReactElement, ReactNode } from 'react';
import { FieldArrayApiInterface, FormApiInterface, FormValues } from '../../types';
declare type FieldArrayApiChildren<Values extends FormValues> = (items: Array<any>, fieldArrayApi: FieldArrayApiInterface, formApi: FormApiInterface<Values>) => ReactNode;
export interface FieldArrayProps<Values extends FormValues> {
    name: string;
    children: FieldArrayApiChildren<Values>;
}
export declare const FieldArray: {
    <Values extends FormValues>({ name, children, }: FieldArrayProps<Values>): ReactElement | null;
    displayName: string;
};
export {};
