import React, { PropsWithoutRef, ReactNode } from 'react';
import { FieldRefProp, GroupApiInterface, GroupsApiInterface } from '../../types';
export interface GroupNavProps extends Omit<React.HTMLProps<HTMLUListElement>, 'children'> {
    onClickGroup?: (group: GroupApiInterface, api: GroupsApiInterface) => void;
    clickNext?: boolean;
    clickPrev?: boolean;
    childNode?: (group: GroupApiInterface, api: GroupsApiInterface) => ReactNode;
}
export declare const GroupNav: {
    ({ onClickGroup, clickNext, clickPrev, childNode, uRef, ...props }: PropsWithoutRef<GroupNavProps & FieldRefProp<HTMLUListElement>>): JSX.Element;
    displayName: string;
};
