import { FieldValueType } from './types';
export declare const generateId: () => string;
export declare const valueToString: (value: FieldValueType, emptyValue?: any) => string;
export declare const stringToValue: (value: string, emptyValue?: any) => string;
export declare const valueToJson: (value: FieldValueType) => string;
export declare const jsonToValue: (json: string) => FieldValueType;
export declare const getValuesDiff: (prev: any, current: any, maxLevel?: number, currentLevel?: number) => any;
export declare const isPromise: (value: any) => boolean;
export declare const isArrayHasPromise: (arr: Array<any>) => boolean;
export declare const isArrayEqual: (x: any, y: any) => boolean;
