/// <reference types="react" />
import { FormStateInterface, FormValues } from './types';
export declare const FormStoreProvider: ({ createStore, children, }: {
    createStore: () => any;
    children: import("react").ReactNode;
}) => import("react").FunctionComponentElement<import("react").ProviderProps<any>>, useFormStore: {
    (): unknown;
    <U>(selector: (state: unknown) => U, equalityFn?: ((a: U, b: U) => boolean) | undefined): U;
};
export declare const createFormStore: <Values extends FormValues>() => import("zustand").UseBoundStore<import("zustand").StoreApi<FormStateInterface<Values>>>;
