import { PropsWithoutRef, ReactElement, ReactNode } from 'react';
import { FieldApiInterface, FieldPassedProps, FormApiInterface, FormValues } from '../../types';
declare type FieldApiChildren<Values extends FormValues> = (fieldApi: FieldApiInterface, formAPi: FormApiInterface<Values>) => ReactNode;
export interface FieldProps<Values extends FormValues> {
    children: FieldApiChildren<Values>;
}
export declare const Field: {
    <Values extends FormValues>({ name, disabled, hideError, children, dependsOn, }: FieldProps<Values> & FieldPassedProps<Values>): ReactElement | null;
    displayName: string;
};
export {};
