import React, { PropsWithoutRef } from 'react';
import { FieldRefProp, FieldValueType } from '../../types';
export interface CheckboxGroupItemProps extends Omit<React.HTMLProps<HTMLInputElement>, 'value' | 'name'> {
    value: FieldValueType;
}
export declare const CheckboxGroupItem: {
    ({ value, uRef, ...props }: PropsWithoutRef<CheckboxGroupItemProps & FieldRefProp<HTMLInputElement>>): JSX.Element;
    displayName: string;
};
